/* dangerous macro! */
#define KHz		* 1000
#define MHz		* 1000 * 1000

static __inline__
int get_rate(const char *s) {
	char *p;
	int val = (int)strtol(s, &p, 0);
	switch(*p) {
	case 'M': case 'm': val *= 1000;
	case 'K': case 'k': val *= 1000;
	break;
	}
	return val;
}

static __inline__
int get_width(const char *s) {
	return (int)strtol(s, NULL, 0);
}

static __inline__
int get_channels(const char *s) {
	return (int)strtol(s, NULL, 0);
}

static __inline__
u_int8_t GetSamplingFlag(int rate, int width, int channels)
{
	u_int8_t sampling = 0;
	switch(rate) {
	default:
	case ( 40 KHz): sampling |= TDS_SAMPLING_40KHZ; break;
	case (100 KHz): sampling |= TDS_SAMPLING_100KHZ; break;
	case (200 KHz): sampling |= TDS_SAMPLING_200KHZ; break;
	case (500 KHz): sampling |= TDS_SAMPLING_500KHZ; break;
	case (  1 MHz): sampling |= TDS_SAMPLING_1MHZ; break;
	case (  2 MHz): sampling |= TDS_SAMPLING_2MHZ; break;
	case (  4 MHz): sampling |= TDS_SAMPLING_4MHZ; break;
	case (  8 MHz): sampling |= TDS_SAMPLING_8MHZ; break;
	case ( 16 MHz): sampling |= TDS_SAMPLING_16MHZ; break;
	}
	switch(width) {
	default:
	case 1: sampling |= TDS_SAMPLING_1BIT; break;
	case 2: sampling |= TDS_SAMPLING_2BIT; break;
	case 4: sampling |= TDS_SAMPLING_4BIT; break;
	case 8: sampling |= TDS_SAMPLING_8BIT; break;
	}
	switch(channels) {
	default:
	case 1: sampling |= TDS_SAMPLING_1CH; break;
	case 4: sampling |= TDS_SAMPLING_4CH; break;
	}
	return sampling;
}
