#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "tdsio.h"


int main(void)
{
	tdsdev_t *tdsdev;
	tds_samp_t sampling;
	char outfile[] = "./tds.data";
	int fd;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv;
	u_int32_t buf[BUFSIZ * 2];


	/* ǥХΥץ */
	tdsdev = TdsOpen(NULL);
	if (tdsdev == NULL) {
		perror("TdsOpen() error ");
		return -1;
	}

	/* ϥեΥץ */
	fd = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
	if (fd == -1) {
		perror("output file open() error");
		goto end;
	}

	/* ץ */
	sampling.freq = 16;
	sampling.unit = 'M';
	sampling.width = 1;
	sampling.channel = 1;
	rv = TdsSetSampling(tdsdev, &sampling);
	if (rv != 0) {
		perror("TdsSetSampling() failed ");
		goto end;
	}

	/* ǥХFIFOꥢ */
	rv = TdsClrBuffer(tdsdev);
	if (rv != 0) {
		perror("TdsClrBuffer() failed ");
		goto end;
	}

	/* 1PPSƱ */
	rv = TdsSync1pps(tdsdev);
	if (rv != 0) {
		perror("TdsSync1pps() failed ");
		goto end;
	}

	/* (OSꤹ) */
	rv = TdsSetTime(tdsdev, NULL);
	if (rv != 0) {
		perror("TdsSetTime() failed ");
		goto end;
	}

	/* ץ󥰳 */
	rv = TdsStart(tdsdev);
	if (rv != 0) {
		perror("TdsStart() failed ");
		goto end;
	}

	/* ǡɤ߹ */
	{
		int c = 0;
		while (c < BUFSIZ * BUFSIZ) {
			int nbyte = sizeof(buf);

			rv = TdsRead(tdsdev, &nbyte, buf);
			if (rv != 0) {
				perror("TdsRead() failed ");
				goto end;
			}
			/* ǡν񤭽Ф */
			rv = write(fd, buf, nbyte);
			c ++;
		}
	}

	/* ץ */
	rv = TdsStop(tdsdev);
	if (rv != 0) {
		perror("TdsStop() failed ");
		goto end;
	}

	/* ϥեΥ */
	close(fd);

 end:
	/* ǥХΥ */
	TdsClose(tdsdev);

	return rv;
}
