#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "tdsio.h"


int main(void)
{
	char dev[] = "/dev/tds0";
	char outfile[] = "/dev/null";
	int fd_in;
	int fd_out;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv;
	u_int8_t sampling;
	u_int32_t buf[BUFSIZ * 2];


	/* ǥХΥץ */
	fd_in = open(dev, O_RDONLY);
	if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	}

	/* ϥեΥץ */
	fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
	if (fd_out == -1) {
		perror("output file open() error");
		goto end;
	}

	/* ץ */
	sampling = TDS_SAMPLING_4MHZ | TDS_SAMPLING_1BIT | TDS_SAMPLING_4CH;
	rv = ioctl(fd_in, TDSIO_SET_SAMPLING, &sampling);
	if (rv == -1) {
		perror("ioctl() sampling set failed ");
		goto end;
	}
	else {
		printf("ioctl() sampling set succeed\n");
	}

	/* ǥХFIFOꥢ */
	rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);
	if (rv == -1) {
		perror("ioctl() FIFO clear failed ");
		goto end;
	}
	else {
		printf("ioctl() FIFO clear succeed\n");
	}

	/* 1PPSƱ */
	rv = ioctl(fd_in, TDSIO_SYNC_1PPS);
	if (rv == -1) {
		perror("ioctl() 1pps sync failed ");
		goto end;
	}
	else {
		printf("ioctl() 1pps sync succeed\n");
	}

	/* Ʊ */
	rv = ioctl(fd_in, TDSIO_SYNC_TIME);
	if (rv == -1) {
		perror("ioctl() time sync failed ");
		goto end;
	}
	else {
		printf("ioctl() time sync succeed\n");
	}

	/* ץ󥰳 */
	rv = ioctl(fd_in, TDSIO_SAMPLING_START);
	if (rv == -1) {
		perror("ioctl() start sampling failed ");
		goto end;
	}
	else {
		printf("ioctl() start sampling succeed\n");
	}

	/* ǡɤ߹ */
	{
		int c = 0;
		while (c < BUFSIZ * BUFSIZ) {
			int nbyte = sizeof(buf);

			rv = read(fd_in, buf, nbyte);
			if (rv == -1) {
				perror("read() failed ");
				goto end;
			}
			/* ǡν񤭽Ф */
			rv = write(fd_out, buf, rv);
			c ++;
		}
	}

	/* ץ */
	rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
	if (rv == -1) {
		perror("ioctl() stop sampling failed ");
		goto end;
	}
	else {
		printf("ioctl() stop sampling succeed\n");
	}

	/* ϥեΥ */
	close(fd_out);

 end:
	/* ǥХΥ */
	close(fd_in);

	return rv;
}
